<template>
  <section class="container">
    <div>
      <h1 class="title">Testa uzdevums</h1>

      <div class="form-group text-left">
        <!-- <label for="userName"></label> -->
        <input
          type="text"
          id="userName"
          name="userName"
          class="form-control"
          placeholder="Ievadi savu vārdu"
          v-model="userName"
          @keyup.enter="startTest()"
        >
      </div>
      <div class="form-group text-left">
        <!-- <label for="testSelection">Izvēlies testu:</label> -->
        <select v-model="testId" class="form-control">
          <option disabled value>Izvēlies testu:</option>
          <option v-for="test in allTests" :key="test._id" :value="test._id">{{test.name}}</option>
        </select>
      </div>
      <div>
        <button type="button" class="btn btn-primary btn-block" v-on:click="startTest()">Sākt</button>
      </div>
    </div>
  </section>
</template>

<script>
export default {
  data: function() {
    return {
      userName: "",
      testId: "",
      allTests: []
    };
  },
  created() {
    this.fetchTests();
    this.$store.commit("test/reset");
  },
  methods: {
    async startTest() {
      if (this.$data.userName !== "" && this.$data.testId !== "") {
        // create a new TestResult entry
        const testResult = await this.$axios.$post(
          process.env.apiUrl + "tests/start",
          {
            userName: this.$data.userName,
            testId: this.$data.testId
          }
        );
        // put data in store
        this.$store.commit("test/start", {
          userName: this.$data.userName,
          testId: this.$data.testId,
          resultId: testResult._id,
          currentQuestionIdx: testResult.currentQuestionIdx
        });
        // navigate to next question
        this.$router.push("test");
      } else {
        this.$notify({
          title: "Uzmanību!",
          text: "Lai turpinātu, nepieciešams ievadīt savu vārdu un izvēlēties testu!",
        });
      }
    },
    async fetchTests() {
      this.$data.allTests = await this.$axios.$get(
        process.env.apiUrl + "tests"
      );
    }
  }
};
</script>

<style>
.container {
  margin: 0 auto;
  min-height: 100vh;
  display: flex;
  justify-content: center;
  align-items: center;
  text-align: center;
}

.title {
  font-family: "Quicksand", "Source Sans Pro", -apple-system, BlinkMacSystemFont,
    "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif;
  display: block;
  font-weight: 300;
  font-size: 65px; 
  color: #35495e;
  letter-spacing: 1px;
}
</style>
